﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace MathExercise1
{
    public class ProjectileManager
    {
        private World mWorld;
        private List<Projectile> mProjectiles;
        private AnimData[] projectileData;

        public ProjectileManager(World containingWorld)
        {
            mWorld = containingWorld;
            mProjectiles = new List<Projectile>();
        }

        public void LoadContent(ContentManager content)
        {
            projectileData = content.Load<AnimData[]>("Missles");
            foreach (AnimData d in projectileData)
            {
                d.Texture = content.Load<Texture2D>(d.spriteName);
            }

        }


        public void CreateProjectile(Vector2 position, Vector2 velocity)
        {
            mProjectiles.Add(new Projectile(projectileData[0].Texture, projectileData[0].animWidth,position, velocity));
        }

        public void Update(GameTime gameTime)
        {
            List<Projectile> toDelete = null;
            foreach (Projectile p in mProjectiles)
            {
                p.Update(gameTime);
                if (p.Postition.X < 0 || p.Postition.X > mWorld.WorldWidth || p.Postition.Y < 0 || p.Postition.Y > mWorld.WorldHeight)
                {
                    if (toDelete == null)
                    {
                        toDelete = new List<Projectile>();
                    }
                    toDelete.Add(p);
                }
            }
            if (toDelete != null)
            {
                foreach (Projectile p in toDelete)
                {
                    mProjectiles.Remove(p);
                }
            }
        }

        public void Draw(SpriteBatch sb)
        {
            foreach (Projectile p in mProjectiles)
            {
                p.Draw(sb);
            }

        }

    }
}
